﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xna_codecamp_v2.Objects
{
    class Node
    {
        private GamePiece slot;

        private SortedList<int, Node> neighbourList;
        public readonly int type; // Use definitions for these
        public int x;
        public int y;
        public int owner; //ownnership of the next

        public Node(int type, GamePiece piece)
        {
            this.type = type;
            this.slot = piece;
            this.neighbourList = new SortedList<int, Node>();
        }

        public int getContentType()
        {
            if (slot != null)
                return slot.type;
            else
                return Definitions.empty;
        }

        public GamePiece removePiece()
        {
            if (slot == null)
                throw new ArgumentException("Slot null!");
            else
            {
                GamePiece temp = this.slot;
                this.slot = null;
                return temp;
            }
        }

        public void addPiece(GamePiece piece)
        {
            if (slot != null)
                throw new ArgumentException("Not empty!");
            else
            {
                this.slot = piece;
            }
        }

        public Node getNeighbour(int direction)
        {
            if (!neighbourList.ContainsKey(direction))
                throw new ArgumentException();
            else
                return neighbourList[direction];
        }

        public void addNeighbour(int direction, Node node)
        {
            neighbourList.Add(direction, node);
        }

        public bool isEmpty()
        {
            if (slot == null)
                return true;
            else return false;
        }

        public GamePiece getContent()
        {
            if (slot != null)
                return slot;
            else return null;
        }

        public SortedList<int, Node> getNeighbourList()
        {
            return this.neighbourList;
        }

    }


      
}
