﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;


namespace Xna_codecamp_v2.Objects
{
    public class Sprite
    {
             // Field indicating sprites status - initialised to false.
        private bool _alive;

        // Field to hold the 2d texture represented by this sprite.
        private Texture2D _spriteTexture;

        // Field to contain the sprites position.
        private Vector2 _position;

        // Field to hold the color used when drawing the sprite.
        private Color _drawColor;

        // Public property used to set / get the alive flag.
        public bool Alive
        {
            set{ _alive = value; }
            get{ return _alive; }
        }

        // Public property used to set / get the 2D texture.
        public Texture2D SpriteTexture
        {
            set{ _spriteTexture = value; }
            get{ return _spriteTexture; }
        }

        // Public property used to set / get the position.
        public Vector2 Position
        {
            set{ _position = value; }
            get{ return _position; }
        }

        // Public property used to set / get the draw color.
        public Color DrawColor
        {
            set{ _drawColor = value; }
            get{ return _drawColor; }
        }

        // Default constructor.
        public Sprite()
        {

        }

        // Constructor used to setup the object.
        public Sprite(bool alive, Texture2D spriteTexture, Vector2 position, Color drawColor)
        {
            // Set the properties
            this.Alive = alive;
            this.SpriteTexture = spriteTexture;
            this.Position = position;
            this.DrawColor = drawColor;
        }





















    }
}
